/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.TipoCortesiaDescuentoDAO;
import com.rjconsultores.ventaboletos.entidad.TipoCortesia;
import com.rjconsultores.ventaboletos.entidad.TipoCortesiaDescuento;
import com.rjconsultores.ventaboletos.service.TipoCortesiaDescuentoService;
import com.rjconsultores.ventaboletos.service.TipoCortesiaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Shiro
 */
@Service("tipoCortesiaDService")
public class TipoCortesiaDescuentoServiceImpl implements TipoCortesiaDescuentoService {

    @Autowired
    private TipoCortesiaDescuentoDAO tipoCortesiaDescuentoDAO;
    @Autowired
    private TipoCortesiaService tcDAO;

    public List<TipoCortesiaDescuento> obtenerTodos() {
        return tipoCortesiaDescuentoDAO.obtenerTodos();
    }

    public TipoCortesiaDescuento obtenerID(Integer id) {
        return tipoCortesiaDescuentoDAO.obtenerID(id);
    }

    @Transactional
    public TipoCortesiaDescuento suscribir(TipoCortesiaDescuento entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return tipoCortesiaDescuentoDAO.suscribir(entidad);
    }

    @Transactional
    public TipoCortesiaDescuento actualizacion(TipoCortesiaDescuento entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return tipoCortesiaDescuentoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(TipoCortesiaDescuento entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        tipoCortesiaDescuentoDAO.actualizacion(entidad);
    }

    public List<TipoCortesiaDescuento> pesquisar(TipoCortesia tipoCortesia) {

        return tipoCortesiaDescuentoDAO.pesquisar(tipoCortesia);

    }

    public List<TipoCortesiaDescuento> Onchangue(TipoCortesia tp) {
        List<TipoCortesia> tc = tcDAO.obtenerTodos();
        TipoCortesia Tcselec = null;
        for (TipoCortesia tpc : tc) {

            if (tpc.getTipocortesiaId().equals(tp.getTipocortesiaId())) {
                Tcselec = tpc;
            }
        }

        return tipoCortesiaDescuentoDAO.Onchangue(Tcselec);
    }

    public List<TipoCortesiaDescuento> buscar(BigDecimal porcentaje,
            TipoCortesia tipoCortesia) {
        return tipoCortesiaDescuentoDAO.buscar(porcentaje, tipoCortesia);
    }

    public List<TipoCortesiaDescuento> obtenerTipoCortesia(int i) {
        return tipoCortesiaDescuentoDAO.obtenerTipoCortesia(i);
    }
}
